/**********
 *	MakeRuler 1.0
 **********
 *	Filename:		MakeRuler.jsx
 *	Written by:		Redsandro - http://www.rednet.nl/en/
 *	Date:			2008/10/30
 *	Last updated:	2008/10/30
 **********
 *
 *	Description:
 *
 *	Creates a horizontal ruler filling your comp. Handy for referencing.
 *
 *	Usage:
 *
 *	You better run this in a precomp, it will create a lot of layers.
 *
 *	Your currently chosen text size and color will be used, so keep it small
 *	(depending on your comp size) like 28px green.
 *
 **********/



clearOutput();

var myComp = app.project.activeItem;
if (myComp == null) {
	alert("You need to have your composition selected. Click on the viewer or the timeline first.");
}

else {
	// Gather data
	var numMain = "18";
	var numSub = "1";
	var numAmnt = "360";
	numMain = parseInt(prompt("How many main instances do you want? (IE. 18 for 360 degree ruler)", numMain));
	numSub = parseInt(prompt("How many sub instances do you want? (IE. 1 to double 18 to 36)", numSub));
	numAmnt = parseInt(prompt("How far does the ruler count? (IE. 360)", numAmnt));
	var numTotal = numMain + numSub * numMain;
	var myLength = myComp.width;
	var myStep = myLength / numTotal;
	var stepAmnt = Math.round(numAmnt/numMain*100)/100;
	var isMain;
	var subCount = 0;

	app.beginUndoGroup("MakeRuler");

	// Create solid
	var tempName = 1 + Math.floor(Math.random() * 999);
	var myLayer = myComp.layers.addSolid([0.5,0.5,0.5], "MakeRuler "+tempName, 10, myComp.height, myComp.pixelAspect, myComp.duration);
	myLayer.guideLayer = false;
	myLayer.threeDLayer = false;
	myLayer.position.setValue([0,myComp.height/2]);

	for (var n=1; n<numTotal; n++) { // Yes we skip the first one so this is zero based
		// Calculate wether current instance is a main one
		if (n%(numSub+1)==0) isMain = true;
		else isMain = false;
		var myPos = [n*myStep,myComp.height/2]

		// Copy layer
		var newLayer = myLayer.duplicate();
		newLayer.position.setValue(myPos);

		if (isMain) {
			subCount+=1;
			newLayer.opacity.setValue(100);
			newLayer.scale.setValue([100,100]);
			// Add number
			txtLayer = myComp.layers.addText(subCount*stepAmnt);
			txtLayer.name = "Ruler Value";
			txtLayer.guideLayer = false;
			txtLayer.threeDLayer = false;
			txtLayer.position.setValue(myPos);
		}
		else {
			newLayer.opacity.setValue(50);
			newLayer.scale.setValue([50,50]);
		}
	}
	app.endUndoGroup();
}

